<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
	<modelVersion>4.0.0</modelVersion>

	<name>NotExtender Client</name>
	<description>A NetExtender Linux CLI wrapper to help deal with the DNS nonsense</description>
	<groupId>cr.cortex.notextender</groupId>
	<artifactId>notextender</artifactId>
	<version>${revision}</version>
	<packaging>jar</packaging>

	<developers>
		<developer>
			<id>drivera</id>
			<name>Diego Rivera</name>
			<email>diego.rivera@cortex.cr</email>
			<roles>
				<role>Architect</role>
				<role>Developer</role>
			</roles>
			<timezone>-6</timezone>
		</developer>
	</developers>

	<scm>
		<connection>scm:git:git@gitlab.com:cortex.cr/java/netetender-ultra.git</connection>
	</scm>

	<properties>
		<revision>1.2.3</revision>
		<maven.min-version>3.3.9</maven.min-version>
		<project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
		<project.build.target>11</project.build.target>
		<build.number>-SNAPSHOT-${scmBranch}-${buildNumber}</build.number>

		<!-- Dependency versions -->
		<commons-io.version>2.11.0</commons-io.version>
		<commons-lang3.version>3.10</commons-lang3.version>
		<commons-validator.version>1.6</commons-validator.version>
		<dbus.version>4.3.0</dbus.version>
		<dbus-nativefd.version>2.0</dbus-nativefd.version>
		<freemarker.version>2.3.30</freemarker.version>
		<jsoup.version>1.15.3</jsoup.version>
		<httpclient.version>4.5.14</httpclient.version>
		<logback.version>1.2.3</logback.version>
		<slf4j.version>1.7.30</slf4j.version>

		<!-- Test dependency versions -->
		<junit.version>5.5.2</junit.version>

	</properties>

	<dependencies>
			<dependency>
				<groupId>org.slf4j</groupId>
				<artifactId>slf4j-api</artifactId>
				<version>${slf4j.version}</version>
				<scope>compile</scope>
			</dependency>

			<dependency>
				<groupId>commons-io</groupId>
				<artifactId>commons-io</artifactId>
				<version>${commons-io.version}</version>
				<scope>compile</scope>
			</dependency>

			<dependency>
				<groupId>org.apache.commons</groupId>
				<artifactId>commons-lang3</artifactId>
				<version>${commons-lang3.version}</version>
				<scope>compile</scope>
			</dependency>

			<dependency>
				<groupId>commons-validator</groupId>
				<artifactId>commons-validator</artifactId>
				<version>${commons-validator.version}</version>
				<scope>compile</scope>
			</dependency>

			<dependency>
				<groupId>com.github.hypfvieh</groupId>
				<artifactId>dbus-java-transport-jnr-unixsocket</artifactId>
				<version>${dbus.version}</version>
				<scope>compile</scope>
			</dependency>

			<dependency>
				<groupId>com.rm5248</groupId>
				<artifactId>dbus-java-nativefd</artifactId>
				<version>${dbus-nativefd.version}</version>
			</dependency>

			<dependency>
				<groupId>org.freemarker</groupId>
				<artifactId>freemarker</artifactId>
				<version>${freemarker.version}</version>
				<scope>compile</scope>
			</dependency>

			<dependency>
				<groupId>org.apache.httpcomponents</groupId>
				<artifactId>httpclient</artifactId>
				<version>${httpclient.version}</version>
				<scope>compile</scope>
			</dependency>

			<dependency>
				<groupId>org.jsoup</groupId>
				<artifactId>jsoup</artifactId>
				<version>${jsoup.version}</version>
				<scope>compile</scope>
			</dependency>

			<dependency>
				<groupId>ch.qos.logback</groupId>
				<artifactId>logback-classic</artifactId>
				<version>${logback.version}</version>
				<scope>compile</scope>
			</dependency>

			<dependency>
				<groupId>org.junit.jupiter</groupId>
				<artifactId>junit-jupiter</artifactId>
				<version>${junit.version}</version>
				<scope>test</scope>
			</dependency>
	</dependencies>

	<build>
		<pluginManagement>
			<plugins>
				<plugin>
					<groupId>org.apache.maven.plugins</groupId>
					<artifactId>maven-enforcer-plugin</artifactId>
					<version>1.4.1</version>
					<configuration>
						<rules>
							<requireMavenVersion>
								<version>${maven.min-version}</version>
							</requireMavenVersion>
						</rules>
					</configuration>
				</plugin>
				<plugin>
					<groupId>org.apache.maven.plugins</groupId>
					<artifactId>maven-source-plugin</artifactId>
					<version>3.0.1</version>
				</plugin>
				<plugin>
					<groupId>org.apache.maven.plugins</groupId>
					<artifactId>maven-compiler-plugin</artifactId>
					<version>3.8.0</version>
					<configuration>
						<encoding>${project.build.sourceEncoding}</encoding>
						<source>${project.build.target}</source>
						<target>${project.build.target}</target>
						<compilerId>eclipse</compilerId>
						<compilerArguments>
							<properties>${project.basedir}/.settings/org.eclipse.jdt.core.prefs</properties>
						</compilerArguments>
						<showWarnings>true</showWarnings>
						<showDeprecation>true</showDeprecation>
					</configuration>
					<dependencies>
						<dependency>
							<groupId>org.codehaus.plexus</groupId>
							<artifactId>plexus-compiler-eclipse</artifactId>
							<version>2.8.5</version>
						</dependency>
						<dependency>
							<groupId>org.eclipse.jdt</groupId>
							<artifactId>ecj</artifactId>
							<version>3.17.0</version>
						</dependency>
					</dependencies>
				</plugin>
				<plugin>
					<groupId>org.apache.maven.plugins</groupId>
					<artifactId>maven-war-plugin</artifactId>
					<version>3.2.1</version>
					<configuration>
						<warSourceDirectory>src/main/webapp</warSourceDirectory>
					</configuration>
				</plugin>
				<plugin>
					<groupId>org.apache.maven.plugins</groupId>
					<artifactId>maven-javadoc-plugin</artifactId>
					<version>3.0.1</version>
					<configuration>
						<failOnError>false</failOnError>
						<doclint>none</doclint>
					</configuration>
				</plugin>
				<plugin>
					<groupId>org.apache.maven.plugins</groupId>
					<artifactId>maven-surefire-plugin</artifactId>
					<version>2.22.1</version>
					<configuration>
						<parallel>classes</parallel>
						<threadCount>10</threadCount>
						<trimStackTrace>false</trimStackTrace>
						<reuseForks>false</reuseForks>
					</configuration>
				</plugin>
				<plugin>
					<groupId>org.apache.maven.plugins</groupId>
					<artifactId>maven-shade-plugin</artifactId>
					<version>3.2.1</version>
					<configuration>
						<finalName>${project.artifactId}-${project.version}${build.number}-exe</finalName>
						<createSourcesJar>true</createSourcesJar>
						<shadeSourcesContent>true</shadeSourcesContent>
						<createDependencyReducedPom>false</createDependencyReducedPom>
						<shadedArtifactAttached>true</shadedArtifactAttached>
						<shadedClassifierName>exe</shadedClassifierName>
						<transformers>
							<transformer implementation="org.apache.maven.plugins.shade.resource.ManifestResourceTransformer">
								<mainClass>cr.cortex.notextender.Main</mainClass>
							</transformer>
							<transformer implementation="org.apache.maven.plugins.shade.resource.ServicesResourceTransformer" />
							<transformer implementation="org.apache.maven.plugins.shade.resource.ApacheNoticeResourceTransformer">
								<addHeader>false</addHeader>
							</transformer>
						</transformers>
					</configuration>
				</plugin>
				<plugin>
					<groupId>org.codehaus.mojo</groupId>
					<artifactId>buildnumber-maven-plugin</artifactId>
					<version>1.4</version>
				</plugin>
				<plugin>
					<groupId>org.apache.maven.plugins</groupId>
					<artifactId>maven-jar-plugin</artifactId>
					<version>3.1.1</version>
					<configuration>
						<archive>
							<manifestEntries>
								<SCM-Branch>${scmBranch}</SCM-Branch>
								<SCM-Revision>${commitHash}</SCM-Revision>
								<SCM-Build-Time>${buildTimestamp}</SCM-Build-Time>
							</manifestEntries>
						</archive>
					</configuration>
				</plugin>
				<plugin>
					<groupId>org.codehaus.mojo</groupId>
					<artifactId>flatten-maven-plugin</artifactId>
					<version>1.3.0</version>
					<configuration>
						<updatePomFile>true</updatePomFile>
						<flattenMode>resolveCiFriendliesOnly</flattenMode>
					</configuration>
				</plugin>
			</plugins>
		</pluginManagement>

		<resources>
			<resource>
				<directory>src/main/resources</directory>
				<filtering>false</filtering>
			</resource>
			<resource>
				<directory>src/main/resources-filtered</directory>
				<filtering>true</filtering>
			</resource>
		</resources>

		<testResources>
			<testResource>
				<directory>src/test/resources</directory>
				<filtering>false</filtering>
			</testResource>
			<testResource>
				<directory>src/test/resources-filtered</directory>
				<filtering>true</filtering>
			</testResource>
		</testResources>

		<plugins>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-enforcer-plugin</artifactId>
				<executions>
					<execution>
						<id>enforce-versions</id>
						<goals>
							<goal>enforce</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.codehaus.mojo</groupId>
				<artifactId>buildnumber-maven-plugin</artifactId>
				<executions>
					<execution>
						<id>create-commitHash</id>
						<phase>generate-sources</phase>
						<goals>
							<goal>create</goal>
						</goals>
						<configuration>
							<doCheck>false</doCheck>
							<doUpdate>false</doUpdate>
							<shortRevisionLength>40</shortRevisionLength>
							<getRevisionOnlyOnce>true</getRevisionOnlyOnce>
							<revisionOnScmFailure>unknown</revisionOnScmFailure>
							<buildNumberPropertyName>commitHash</buildNumberPropertyName>
						</configuration>
					</execution>
					<execution>
						<id>create-buildNumber</id>
						<phase>generate-sources</phase>
						<goals>
							<goal>create</goal>
						</goals>
						<configuration>
							<doCheck>false</doCheck>
							<doUpdate>false</doUpdate>
							<shortRevisionLength>8</shortRevisionLength>
							<getRevisionOnlyOnce>true</getRevisionOnlyOnce>
							<revisionOnScmFailure>unknown</revisionOnScmFailure>
							<buildNumberPropertyName>buildNumber</buildNumberPropertyName>
						</configuration>
					</execution>
					<execution>
						<id>create-buildTimestamp</id>
						<phase>generate-sources</phase>
						<goals>
							<goal>create-timestamp</goal>
						</goals>
						<configuration>
							<timestampPropertyName>buildTimestamp</timestampPropertyName>
							<timestampFormat>yyyy-MM-dd'T'HH:mm:ssZZ</timestampFormat>
							<timezone>UTC</timezone>
						</configuration>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-source-plugin</artifactId>
				<executions>
					<execution>
						<id>attach-sources</id>
						<phase>package</phase>
						<goals>
							<goal>jar-no-fork</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-javadoc-plugin</artifactId>
				<executions>
					<execution>
						<id>attach-javadocs</id>
						<phase>package</phase>
						<goals>
							<goal>jar</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.codehaus.mojo</groupId>
				<artifactId>flatten-maven-plugin</artifactId>
				<executions>
					<execution>
						<id>flatten.process-resources</id>
						<phase>process-resources</phase>
						<goals>
							<goal>flatten</goal>
						</goals>
					</execution>
					<execution>
						<id>flatten.clean</id>
						<phase>clean</phase>
						<goals>
							<goal>clean</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-shade-plugin</artifactId>
				<executions>
					<execution>
						<phase>package</phase>
						<goals>
							<goal>shade</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
		</plugins>
	</build>

	<profiles>
		<profile>
			<id>release</id>
			<properties>
				<build.number>-release</build.number>
			</properties>
		</profile>
		<profile>
			<id>beta</id>
			<properties>
				<build.number>-beta-${betaNumber}</build.number>
			</properties>
			<build>
				<plugins>
					<plugin>
						<groupId>org.apache.maven.plugins</groupId>
						<artifactId>maven-enforcer-plugin</artifactId>
						<version>1.4.1</version>
						<configuration>
							<rules>
								<requireMavenVersion>
									<version>${maven.min-version}</version>
								</requireMavenVersion>
								<requireProperty>
									<property>betaNumber</property>
									<message>Must provide a valid betaNumber property (-DbetaNumber=...) for this build</message>
									<regex>^[0-9]*[1-9]0?$</regex>
									<regexMessage>The beta number [${betaNumber}] is not composed of all digits, or is not a valid number (it may not be
										all-zeros, but may have leading zeros)</regexMessage>
								</requireProperty>
							</rules>
						</configuration>
					</plugin>
				</plugins>
			</build>
		</profile>
	</profiles>
</project>
